package problem5;

import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Calendar;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

public class MainFrame extends JFrame{

	int inputFileState=0;
	int outputFileState=0;
	File inputFile;
	File outputFile;
	JTextField inputFileText=new JTextField("̓t@C");
	JTextField outputFileText=new JTextField("o̓t@C");
	JButton inputFileSetter=new JButton("Q");
	JButton outputFileSetter=new JButton("Q");
	JButton start=new JButton("s");

	public MainFrame(){
		this.setLayout(new GridLayout(3,3));
		//add
		inputFileText.setEnabled(false);
		outputFileText.setEnabled(false);
		start.setEnabled(false);
		Container container=this.getContentPane();
		container.add(new JLabel("̓t@C"));
		container.add(inputFileText);
		container.add(inputFileSetter);
		container.add(new JLabel("o̓t@C"));
		container.add(outputFileText);
		container.add(outputFileSetter);
		container.add(new JLabel(""));
		container.add(start);
		container.add(new JLabel(""));
		//setting
		this.setTitle("ۑ5");
		this.pack();
		this.setLocationRelativeTo(null);
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setVisible(true);
		//listener
		inputFileSetter.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				JFileChooser fileChooser=new JFileChooser();
				fileChooser.setDialogTitle("̓t@C");
				if(fileChooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION){
					inputFile=fileChooser.getSelectedFile();
					inputFileText.setText(inputFile.getAbsolutePath());
					inputFileState=1;
					if(outputFileState==1){
						start.setEnabled(true);
					}
				}
			}
		});
		outputFileSetter.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				JFileChooser fileChooser=new JFileChooser();
				fileChooser.setDialogTitle("o̓t@C");
				if(fileChooser.showOpenDialog(null)==JFileChooser.APPROVE_OPTION){
					outputFile=fileChooser.getSelectedFile();
					outputFileText.setText(outputFile.getAbsolutePath());
					outputFileState=1;
					if(inputFileState==1){
						start.setEnabled(true);
					}
				}
			}
		});
		start.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				try {
					//input-output open
					FileReader reader=new FileReader(inputFile);
					BufferedReader input=new BufferedReader(reader);
					outputFile.createNewFile();
					FileWriter writer=new FileWriter(outputFile);
					BufferedWriter output=new BufferedWriter(writer);
					
					//read number of connections.
					int conneNum=Integer.parseInt(input.readLine());
					//if connections = 0 then end.
					while(conneNum!=0){
						
						//read conections
						Conne conne[]=new Conne[conneNum];
						Citys citys=new Citys();
						for(int i=0;i<conneNum;i++){
							conne[i]=new Conne(input.readLine(),citys);
						}
						
/*						//test
						for(int i=0;i<conneNum;i++){
							Conne tempConne=conne[i];
							String tempStartCity=tempConne.startCity;
							String tempArrivalCity=tempConne.startCity;
							Calendar tempStartTime=tempConne.startTime;
							Calendar tempArrivalTime=tempConne.arrivalTime;
							int tempPrice=tempConne.price;
							output.write(Integer.toString(tempStartTime.get(Calendar.HOUR_OF_DAY)));
							output.write(":");
							output.write(Integer.toString(tempStartTime.get(Calendar.MINUTE)));
							output.write(" ");
							output.write(tempStartCity);
							output.write("	");
							output.write(Integer.toString(tempArrivalTime.get(Calendar.HOUR_OF_DAY)));
							output.write(":");
							output.write(Integer.toString(tempArrivalTime.get(Calendar.MINUTE)));
							output.write(" ");
							output.write(tempArrivalCity);
							output.write("	");
							output.write(Integer.toString(tempPrice));
							output.newLine();
							output.flush();
						}
						//test
*/						
						//startTime
						Calendar startTime=Calendar.getInstance();
						startTime.set(2000,0,1);
						startTime.set(Calendar.HOUR_OF_DAY,8);
						startTime.set(Calendar.MINUTE,0);
						startTime.set(Calendar.SECOND,0);
						Calendar endTime=Calendar.getInstance();
						endTime.set(2000,0,1);
						endTime.set(Calendar.HOUR_OF_DAY,18);
						endTime.set(Calendar.MINUTE,0);
						endTime.set(Calendar.SECOND,0);
						((FromTo)citys.get("Tokyo")).comeFromTokyo.add(startTime,0);
						((FromTo)citys.get("Tokyo")).backToTokyo.add(endTime,0);
						((FromTo)citys.get("Hakodate")).comeFromHakodate.add(startTime,0);
						((FromTo)citys.get("Hakodate")).backToHakodate.add(endTime,0);

						//startTime sort
						Vector conneStartSort=new Vector();
						for(int i=0;i<conneNum;i++){
							int j=0;
							while(j<conneStartSort.size()){
								if(conne[i].startTime.after(((Conne)conneStartSort.get(j)).startTime)){
									j++;
								}
								else{
									break;
								}
							}
							conneStartSort.add(j,conne[i]);
						}
						//arrivalTime sort
						Vector conneArrivalSort=new Vector();
						for(int i=0;i<conneNum;i++){
							int j=0;
							while(j<conneArrivalSort.size()){
								if(conne[i].arrivalTime.before(((Conne)conneArrivalSort.get(j)).arrivalTime)){
									j++;
								}
								else{
									break;
								}
							}
							conneArrivalSort.add(j,conne[i]);
						}
						
						//set ComeFrom
						for(int i=0;i<conneNum;i++){
							String conneStartCity=((Conne)conneStartSort.get(i)).startCity;
							String conneArrivalCity=((Conne)conneStartSort.get(i)).arrivalCity;
							Calendar conneStartTime=((Conne)conneStartSort.get(i)).startTime;
							Calendar conneArrivalTime=((Conne)conneStartSort.get(i)).arrivalTime;
							int connePrice=((Conne)conneStartSort.get(i)).price;
							int priceComeFromeTokyo=((FromTo)(citys.get(conneStartCity))).comeFromTokyo.price(conneStartTime);
							int priceComeFromeHakodate=((FromTo)(citys.get(conneStartCity))).comeFromHakodate.price(conneStartTime);
							if(priceComeFromeTokyo!=Integer.MAX_VALUE){
								priceComeFromeTokyo+=connePrice;
								((FromTo)(citys.get(conneArrivalCity))).comeFromTokyo.add(conneArrivalTime,priceComeFromeTokyo);
							}
							if(priceComeFromeHakodate!=Integer.MAX_VALUE){
								priceComeFromeHakodate+=connePrice;
								((FromTo)(citys.get(conneArrivalCity))).comeFromHakodate.add(conneArrivalTime,priceComeFromeHakodate);
							}
						}
						
						//set BackTo
						for(int i=0;i<conneNum;i++){
							String conneStartCity=((Conne)conneArrivalSort.get(i)).startCity;
							String conneArrivalCity=((Conne)conneArrivalSort.get(i)).arrivalCity;
							Calendar conneStartTime=((Conne)conneArrivalSort.get(i)).startTime;
							Calendar conneArrivalTime=((Conne)conneArrivalSort.get(i)).arrivalTime;
							int connePrice=((Conne)conneArrivalSort.get(i)).price;
							int priceBackToTokyo=((FromTo)(citys.get(conneArrivalCity))).backToTokyo.price(conneArrivalTime);
							int priceBackToHakodate=((FromTo)(citys.get(conneArrivalCity))).backToHakodate.price(conneArrivalTime);
							if(priceBackToTokyo!=Integer.MAX_VALUE){
								priceBackToTokyo+=connePrice;
								((FromTo)(citys.get(conneStartCity))).backToTokyo.add(conneStartTime,priceBackToTokyo);
							}
							if(priceBackToHakodate!=Integer.MAX_VALUE){
								priceBackToHakodate+=connePrice;
								((FromTo)(citys.get(conneStartCity))).backToHakodate.add(conneStartTime,priceBackToHakodate);
							}
						}
						
						//minPrice
						int minPrice=Integer.MAX_VALUE;
						for(int i=0;i<citys.keys.size();i++){
//							JOptionPane.showMessageDialog(null,citys.keys.get(i));
							((FromTo)(citys.get(citys.keys.get(i)))).flush();
							minPrice=Math.min(minPrice,((FromTo)citys.get(citys.keys.get(i))).getMinPrice());
							
							
							
/*							//test
							String tempCity=(String) citys.keys.get(i);
							output.write(tempCity);
							output.newLine();
							output.flush();

							output.write("ComeFromTokyo");
							output.newLine();
							output.flush();
							ComeFrom comeFrom=((FromTo)(citys.get(tempCity))).comeFromTokyo;
							for(int j=0;j<comeFrom.size();j++){
								Calendar time=comeFrom.getTime(j);
								int price=comeFrom.getPrice(j);
								output.write(Integer.toString(time.get(Calendar.HOUR_OF_DAY)));
								output.write(":");
								output.write(Integer.toString(time.get(Calendar.MINUTE)));								
								output.write("	");
								output.write(Integer.toString(price));
								output.newLine();
								output.flush();
							}
							
							output.write("ComeFromHakodate");
							output.newLine();
							output.flush();
							comeFrom=((FromTo)(citys.get(tempCity))).comeFromHakodate;
							for(int j=0;j<comeFrom.size();j++){
								Calendar time=comeFrom.getTime(j);
								int price=comeFrom.getPrice(j);
								output.write(Integer.toString(time.get(Calendar.HOUR_OF_DAY)));
								output.write(":");
								output.write(Integer.toString(time.get(Calendar.MINUTE)));								
								output.write("	");
								output.write(Integer.toString(price));
								output.newLine();
								output.flush();
							}

							output.write("BackToTokyo");
							output.newLine();
							output.flush();
							BackTo backTo=((FromTo)(citys.get(tempCity))).backToTokyo;
							for(int j=0;j<backTo.size();j++){
								Calendar time=backTo.getTime(j);
								int price=backTo.getPrice(j);
								output.write(Integer.toString(time.get(Calendar.HOUR_OF_DAY)));
								output.write(":");
								output.write(Integer.toString(time.get(Calendar.MINUTE)));								
								output.write("	");
								output.write(Integer.toString(price));
								output.newLine();
								output.flush();
							}

							output.write("BackToHakodate");
							output.newLine();
							output.flush();
							backTo=((FromTo)(citys.get(tempCity))).backToHakodate;
							for(int j=0;j<backTo.size();j++){
								Calendar time=backTo.getTime(j);
								int price=backTo.getPrice(j);
								output.write(Integer.toString(time.get(Calendar.HOUR_OF_DAY)));
								output.write(":");
								output.write(Integer.toString(time.get(Calendar.MINUTE)));								
								output.write("	");
								output.write(Integer.toString(price));
								output.newLine();
								output.flush();
							}
							
							output.write("Hello");
							output.newLine();
							output.flush();
							comeFrom=((FromTo)(citys.get(tempCity))).hello;
							for(int j=0;j<comeFrom.size();j++){
								Calendar time=comeFrom.getTime(j);
								int price=comeFrom.getPrice(j);
								output.write(Integer.toString(time.get(Calendar.HOUR_OF_DAY)));
								output.write(":");
								output.write(Integer.toString(time.get(Calendar.MINUTE)));								
								output.write("	");
								output.write(Integer.toString(price));
								output.newLine();
								output.flush();
							}
							
							output.write("Goodby");
							output.newLine();
							output.flush();
							backTo=((FromTo)(citys.get(tempCity))).goodby;
							for(int j=0;j<backTo.size();j++){
								Calendar time=backTo.getTime(j);
								int price=backTo.getPrice(j);
								output.write(Integer.toString(time.get(Calendar.HOUR_OF_DAY)));
								output.write(":");
								output.write(Integer.toString(time.get(Calendar.MINUTE)));								
								output.write("	");
								output.write(Integer.toString(price));
								output.newLine();
								output.flush();
							}
							output.newLine();
							output.flush();
							//test
							 */
							
							
						}
						if(minPrice==Integer.MAX_VALUE){
							output.write("0");
							output.newLine();
							output.flush();
						}
						else{
							output.write(Integer.toString(minPrice));
							output.newLine();
							output.flush();
						}
						
						//read number of next connections
						conneNum=Integer.parseInt(input.readLine());
					}
					//input-output close				
					input.close();
					output.close();
					JOptionPane.showMessageDialog(null,"I܂B");				
				} catch (FileNotFoundException e) {
					e.printStackTrace();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		});
		
	}

}
